(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('rxjs'), require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('pip-webui2-themes', ['exports', 'rxjs', '@angular/core'], factory) :
    (factory((global['pip-webui2-themes'] = {}),global.rxjs,global.ng.core));
}(this, (function (exports,rxjs,core) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Theme = /** @class */ (function () {
        function Theme() {
            this.palette = 'light';
        }
        return Theme;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ThemesConfig = /** @class */ (function () {
        function ThemesConfig() {
        }
        return ThemesConfig;
    }());
    /** @type {?} */
    var THEMES_CONFIG = new core.InjectionToken('themes service config');
    /** @type {?} */
    var DEFAULT_THEMES_CONFIG = new ThemesConfig();
    DEFAULT_THEMES_CONFIG.defaultThemeName = 'pip-blue-theme';
    DEFAULT_THEMES_CONFIG.themes = [
        {
            name: 'candy-theme',
            palette: 'light'
        },
        {
            name: 'unicorn-dark-theme',
            palette: 'dark'
        },
        {
            name: 'pip-blue-theme',
            palette: 'light'
        },
        {
            name: 'pip-grey-theme',
            palette: 'light'
        },
        {
            name: 'pip-navy-theme',
            palette: 'light'
        },
        {
            name: 'pip-amber-theme',
            palette: 'light'
        },
        {
            name: 'pip-green-theme',
            palette: 'light'
        },
        {
            name: 'pip-orange-theme',
            palette: 'light'
        },
        {
            name: 'pip-pink-theme',
            palette: 'light'
        },
        {
            name: 'pip-dark-theme',
            palette: 'dark'
        },
        {
            name: 'pip-black-theme',
            palette: 'dark'
        },
        {
            name: 'bootbarn-warm-theme',
            palette: 'light'
        },
        {
            name: 'bootbarn-cool-theme',
            palette: 'light'
        },
        {
            name: 'bootbarn-mono-theme',
            palette: 'light'
        },
        {
            name: 'mst-black-theme',
            palette: 'light'
        },
        {
            name: 'mst-black-dark-theme',
            palette: 'dark'
        },
        {
            name: 'mst-mono-theme',
            palette: 'light'
        },
        {
            name: 'mst-orange-theme',
            palette: 'light'
        },
        {
            name: 'mst-orange-dark-theme',
            palette: 'dark'
        },
        {
            name: 'mst-elegant-theme',
            palette: 'dark'
        }
    ];
    DEFAULT_THEMES_CONFIG.lsKey = 'theme';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m)
            return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length)
                    o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PipThemesService = /** @class */ (function () {
        function PipThemesService(config) {
            var e_1, _a;
            this.config = config;
            this._selectedTheme = new Theme();
            // Load theme name from the local storage
            /** @type {?} */
            var name = window.localStorage.getItem(this.config.lsKey);
            try {
                // Set theme name
                for (var _b = __values(this.config.themes), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var theme = _c.value;
                    if (theme.name === name) {
                        this._selectedTheme = theme;
                        break;
                    }
                    else if (this._selectedTheme == null || theme.name === this.config.defaultThemeName) {
                        this._selectedTheme = theme;
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            // Create observables
            this._themes$ = new rxjs.BehaviorSubject(this.config.themes);
            this._selectedTheme$ = new rxjs.BehaviorSubject(this._selectedTheme);
            this._selectedThemeName$ = new rxjs.BehaviorSubject(this._selectedTheme.name);
            this.selectedTheme = this._selectedTheme;
        }
        Object.defineProperty(PipThemesService.prototype, "themes$", {
            get: /**
             * @return {?}
             */ function () {
                return this._themes$;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PipThemesService.prototype, "themes", {
            get: /**
             * @return {?}
             */ function () {
                return this.config.themes;
            },
            set: /**
             * @param {?} themes
             * @return {?}
             */ function (themes) {
                this.config.themes = themes;
                this._themes$.next(themes);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PipThemesService.prototype, "selectedThemeName", {
            get: /**
             * @return {?}
             */ function () {
                return this._selectedTheme && this._selectedTheme.name;
            },
            set: /**
             * @param {?} name
             * @return {?}
             */ function (name) {
                var e_2, _a;
                try {
                    for (var _b = __values(this.config.themes), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var theme = _c.value;
                        if (theme.name === name) {
                            this.selectedTheme = theme;
                            break;
                        }
                    }
                }
                catch (e_2_1) {
                    e_2 = { error: e_2_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_2)
                            throw e_2.error;
                    }
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PipThemesService.prototype, "selectedTheme$", {
            get: /**
             * @return {?}
             */ function () {
                return this._selectedTheme$;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PipThemesService.prototype, "selectedTheme", {
            get: /**
             * @return {?}
             */ function () {
                return this._selectedTheme;
            },
            set: /**
             * @param {?} theme
             * @return {?}
             */ function (theme) {
                if (theme == null) {
                    return;
                }
                // Save selected theme to local storage
                window.localStorage.setItem(this.config.lsKey, theme.name);
                // Remove old theme name as a class to body
                document.body.classList.remove(this._selectedTheme.name);
                this._selectedTheme = theme;
                this._selectedTheme$.next(this._selectedTheme);
                // Add new theme name as a class to body
                document.body.classList.add(theme.name);
            },
            enumerable: true,
            configurable: true
        });
        PipThemesService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        PipThemesService.ctorParameters = function () {
            return [
                { type: ThemesConfig, decorators: [{ type: core.Inject, args: [THEMES_CONFIG,] }] }
            ];
        };
        return PipThemesService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PipThemesModule = /** @class */ (function () {
        function PipThemesModule() {
        }
        /**
         * @return {?}
         */
        PipThemesModule.forRoot = /**
         * @return {?}
         */
            function () {
                return {
                    ngModule: PipThemesModule,
                    providers: [
                        PipThemesService,
                        {
                            provide: THEMES_CONFIG,
                            useValue: DEFAULT_THEMES_CONFIG
                        }
                    ]
                };
            };
        PipThemesModule.decorators = [
            { type: core.NgModule }
        ];
        return PipThemesModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.PipThemesModule = PipThemesModule;
    exports.PipThemesService = PipThemesService;
    exports.Theme = Theme;
    exports.ThemesConfig = ThemesConfig;
    exports.THEMES_CONFIG = THEMES_CONFIG;
    exports.DEFAULT_THEMES_CONFIG = DEFAULT_THEMES_CONFIG;
    exports.ɵd = DEFAULT_THEMES_CONFIG;
    exports.ɵc = THEMES_CONFIG;
    exports.ɵb = ThemesConfig;
    exports.ɵa = PipThemesService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=pip-webui2-themes.umd.js.map